#!/bin/bash

# Author: Rossana Motta -  email: rossana.hell.no.127.0.0.1@gmail.com - http://ww2.cs.fsu.edu/~motta
# Version: 1.1
# Date: Dec 25th 2006 [I always get bored on Christmas days.. ;) ]
#
#  **  A very simple script for quick conversions between the most common units. See the Readme file for details.
#  **  Basically you just need to do two quick operations:
#
#   1) copy both the included files (conver.sh and Conversions.desktop) in the KDE servicemenus folders, 
#	that is located in /home/<your_username>/.kde/share/apps/konqueror/servicemenus 
#   2) make the file conver.sh executable by everyone: 
#		to do this, just change directory into servicemenus folder, 
#		then type:		 chmod a+x conver.sh
#
# 	~~~~~~~~	Done!	~~~~~~~~	

VALUE_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Temperature" "Currency" "Weight" "Distance" "Velocity" "Degrees" "Volume" "Area" `

if [[ $VALUE_TYPE == "" ]]
then
    exit;
fi

case "$VALUE_TYPE" in

"Temperature")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Farenheit to Celsius" "Celsius to Farenheit" ` ;;

"Currency")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Euro to U.S. Dollar" "U.S. Dollar to Euro" "~~~~~~~~~~~~~~~~" "British Pound to U.S. Dollar" "U.S. Dollar to British Pound" "~~~~~~~~~~~~~~~~" "British Pound to Euro" "Euro to British Pound" "~~~~~~~~~~~~~~~~" "Canadian Dollar to U.S. Dollar" "U.S. Dollar to Canadian Dollar" "~~~~~~~~~~~~~~~~" "Euro to Canadian Dollar" "Canadian Dollar to Euro" "~~~~~~~~~~~~~~~~" "Japanese Yen to U.S. Dollar" "U.S. Dollar to Japanese Yen" "~~~~~~~~~~~~~~~~" "Euro to Japanese Yen" "Japanese Yen to Euro" "~~~~~~~~~~~~~~~~" "Indian Rupee to U.S. Dollar" "U.S. Dollar to Indian Rupee"` ;;

"Weight")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Pounds to Kilograms" "Kilograms to Pounds" `;;

"Distance")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Miles to Kilometers" "Kilometers to Miles" "Inches to Centimeters" "Centimeters to Inches" "Feet to Meters" "Meters to Feet" "Yards to Meters" "Meters to Yards"`;;

"Velocity")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Km/hr to Miles/hr" "Miles/hr to Km/hr"`;;

"Degrees")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Degrees to Radians" "Radians to Degrees"`;;

"Volume")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "U.K. Ounces to Milliliters" "Milliliters to U.K. Ounces" "~~~~~~~~~~~~~~~~" "U.S. Ounces to Milliliters" "Milliliters to U.S. Ounces" "~~~~~~~~~~~~~~~~" "U.K. Gallons to Liters" "Liters to U.K. Gallons" "~~~~~~~~~~~~~~~~" "U.S. Gallons (Liquid) to Liters" "Liters to U.S. Gallons (Liquid)" "~~~~~~~~~~~~~~~~" "U.S. Gallons (Dry) to Liters" "Liters to U.S. Gallons (Dry)"`;;

"Area")
CONVERSION_TYPE=`kdialog --combobox "Select the type of conversion you wanna do:" "Acres to Sq Meters" "Sq Meters to Acres" "Sq Feet to Sq Meters" "Sq Meters to Sq Feet"`;;


*) exit;;

esac

VALUE=`kdialog --inputbox "Enter the value to convert." 1`;

if [[ $VALUE == "" ]]
then
    exit;
fi

output_conversion=""

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~  CURRENCIES VALUES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# 		UPDATE THE EXACT VALUES OF CURRENCIES HERE

USdollar_euro=0.7615  # That is, 1 $ = 0.7615 €
pound_euro=1.49
pound_dollar=1.96
USdollar_CanadianDollar=1.1584
euro_CanadianDollar=1.5222
IndianRupee_USdollar=0.02250
JapaneseYen_USdollar=0.008416
JapaneseYen_euro=0.006405

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

mile_kilometer=0.62
lib_kilogram=0.454
inch_centimeter=2.54
meter_feet=3.2808
yard_meter=0.914
ounceUK_milliliter=28.413
ounceUS_milliliter=29.574
gallonUK_liter=4.546
gallonUSliquid_liter=3.785
gallonUSdry_liter=4.405
degree_radian=0.01745329251994329547
acre_sqmeter=4046.873
sqfoot_sqmeter=0.093
Kmph_mph=0.621


case "$CONVERSION_TYPE" in 

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   TEMPERATURE   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"Farenheit to Celsius")
		output_conversion=$(echo "scale=3; ($VALUE-32)/1.8" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Farheneit to Celsius: $VALUE °F = $output_conversion °C" --title "Result Of The Conversion"); fi ;;

	"Celsius to Farenheit") 
		output_conversion=$(echo "scale=3; $VALUE*1.8 +32" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Celsius to Farheneit: $VALUE °C = $output_conversion °F." --title "Result Of The Conversion"); fi ;;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   CURRENCIES   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"Euro to U.S. Dollar") 
		output_conversion=$(echo "scale=3; $VALUE/$USdollar_euro" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Euros to U.S. Dollars: $VALUE € = $output_conversion $." --title "Result Of The Conversion"); fi ;;

	"U.S. Dollar to Euro") 
		output_conversion=$(echo "scale=3; $VALUE*$USdollar_euro" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Dollars to Euros: $VALUE $ = $output_conversion €." --title "Result Of The Conversion"); fi ;;


	"British Pound to U.S. Dollar") 
		output_conversion=$(echo "scale=3; $VALUE*$pound_dollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Pounds to U.S. Dollars: $VALUE £ = $output_conversion $." --title "Result Of The Conversion"); fi  ;;

	"U.S. Dollar to British Pound") 
		output_conversion=$(echo "scale=3; $VALUE/$pound_dollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Dollars to Pounds: $VALUE $ = $output_conversion £." --title "Result Of The Conversion"); fi ;;


	"British Pound to Euro")
		output_conversion=$(echo "scale=3; $VALUE*$pound_euro" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from British Pounds to Euros: $VALUE £ = $output_conversion €." --title "Result Of The Conversion"); fi  ;;

	"Euro to British Pound") 
		output_conversion=$(echo "scale=3; $VALUE/$pound_euro" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Euros to British Pounds: $VALUE € = $output_conversion £." --title "Result Of The Conversion"); fi ;;


	"Canadian Dollar to U.S. Dollar") 
		output_conversion=$(echo "scale=3; $VALUE/$USdollar_CanadianDollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Canadian Dollars to U.S. Dollars: $VALUE CAD = $output_conversion $." --title "Result Of The Conversion"); fi ;;

	"U.S. Dollar to Canadian Dollar") 
		output_conversion=$(echo "scale=3; $VALUE*$USdollar_CanadianDollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Dollars to Canadian Dollars: $VALUE $ = $output_conversion CAD." --title "Result Of The Conversion"); fi ;;


	"Euro to Canadian Dollar") 
		output_conversion=$(echo "scale=3; $VALUE*$euro_CanadianDollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Euros to Canadian Dollars: $VALUE € = $output_conversion CAD." --title "Result Of The Conversion"); fi ;;

	"Canadian Dollar to Euro") 
		output_conversion=$(echo "scale=3; $VALUE/$euro_CanadianDollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Canadian Dollars to Euros: $VALUE CAD = $output_conversion €." --title "Result Of The Conversion"); fi ;;


	"Japanese Yen to U.S. Dollar") 
		output_conversion=$(echo "scale=3; $VALUE*$JapaneseYen_USdollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Japanese Yen to U.S. Dollars: $VALUE Japanese Yen = $output_conversion $." --title "Result Of The Conversion"); fi ;;

	"U.S. Dollar to Japanese Yen") 
		output_conversion=$(echo "scale=3; $VALUE/$JapaneseYen_USdollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Dollars to Japanese Yen: $VALUE $ = $output_conversion Japanese Yen." --title "Result Of The Conversion"); fi ;;


	"Euro to Japanese Yen") 
		output_conversion=$(echo "scale=3; $VALUE/$JapaneseYen_euro" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Euros to Japanese Yen: $VALUE € = $output_conversion Japanese Yen." --title "Result Of The Conversion"); fi ;;

	"Japanese Yen to Euro") 
		output_conversion=$(echo "scale=3; $VALUE*$JapaneseYen_euro" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Japanese Yen to Euros: $VALUE Japanese Yen = $output_conversion €." --title "Result Of The Conversion"); fi ;;


	"Indian Rupee to U.S. Dollar") 
		output_conversion=$(echo "scale=3; $VALUE*$IndianRupee_USdollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else (kdialog --msgbox "Conversion from Indian Rupee to U.S. Dollars: $VALUE Indian Rupee = $output_conversion $." --title "Result Of The Conversion"); fi ;;

	"U.S. Dollar to Indian Rupee") 
		output_conversion=$(echo "scale=3; $VALUE/$IndianRupee_USdollar" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Dollars to Indian Rupee: $VALUE $ = $output_conversion Indian Rupee." --title "Result Of The Conversion"); fi ;;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   DISTANCE   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"Miles to Kilometers") 
		output_conversion=$(echo "scale=3; $VALUE/$mile_kilometer" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Miles to Kilometers: $VALUE mi = $output_conversion Km." --title "Result Of The Conversion"); fi  ;;

	"Kilometers to Miles") 
		output_conversion=$(echo "scale=3; $VALUE*$mile_kilometer" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Kilometers to Miles: $VALUE Km = $output_conversion mi." --title "Result Of The Conversion"); fi  ;;

	"Meters to Feet") 
		output_conversion=$(echo "scale=3; $VALUE*$meter_feet" | bc)
		if [ -z "$output_conversion" ];then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit) 
		else (kdialog --msgbox "Conversion from Meters to Feet: $VALUE mt = $output_conversion feet." --title "Result Of The Conversion"); fi  ;;

	"Feet to Meters") 
		output_conversion=$(echo "scale=3; $VALUE/$meter_feet" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Feet to Meters: $VALUE feet = $output_conversion mt." --title "Result Of The Conversion"); fi  ;;

	"Centimeters to Inches") 
		output_conversion=$(echo "scale=3; $VALUE/$inch_centimeter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Centimeters to Inches: $VALUE cm = $output_conversion in." --title "Result Of The Conversion"); fi  ;;

	"Inches to Centimeters") 
		output_conversion=$(echo "scale=3; $VALUE*$inch_centimeter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Inches to Centimeters: $VALUE in = $output_conversion cm." --title "Result Of The Conversion"); fi  ;;

	"Yards to Meters")
		output_conversion=$(echo "scale=3; $VALUE*$yard_meter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Yards to Meters: $VALUE Yard = $output_conversion mt." --title "Result Of The Conversion"); fi  ;;

	"Meters to Yards")
		output_conversion=$(echo "scale=3; $VALUE/$yard_meter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Meters to Yards: $VALUE mt = $output_conversion Yards." --title "Result Of The Conversion"); fi  ;;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   WEIGHT   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"Pounds to Kilograms") 
		output_conversion=$(echo "scale=3; $VALUE*$lib_kilogram" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from lb to Kilograms: $VALUE lb = $output_conversion Kg." --title "Result Of The Conversion"); fi  ;;

	"Kilograms to Pounds") 
		output_conversion=$(echo "scale=3; $VALUE/$lib_kilogram" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Kilograms to lb: $VALUE Kg = $output_conversion lb." --title "Result Of The Conversion"); fi  ;;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   VOLUME   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"U.K. Ounces to Milliliters")
		output_conversion=$(echo "scale=3; $VALUE*$ounceUK_milliliter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.K. Ounces to Milliliters: $VALUE U.K. Oz = $output_conversion ml." --title "Result Of The Conversion"); fi  ;;

	"Milliliters to U.K. Ounces")
		output_conversion=$(echo "scale=3; $VALUE/$ounceUK_milliliter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Milliliters to U.K. Ounces: $VALUE ml = $output_conversion U.K. Oz." --title "Result Of The Conversion"); fi  ;;

	"U.S. Ounces to Milliliters")
		output_conversion=$(echo "scale=3; $VALUE*$ounceUK_milliliter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Ounces to Milliliters: $VALUE U.S. Oz = $output_conversion ml." --title "Result Of The Conversion"); fi  ;;

	"Milliliters to U.S. Ounces")
		output_conversion=$(echo "scale=3; $VALUE/$ounceUK_milliliter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Milliliters to U.S. Ounces: $VALUE ml = $output_conversion U.S. Oz." --title "Result Of The Conversion"); fi  ;;

	"U.K. Gallons to Liters")
		output_conversion=$(echo "scale=3; $VALUE*$gallonUK_liter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.K. Gallons to Liters: $VALUE U.K. Gallons = $output_conversion lt." --title "Result Of The Conversion"); fi  ;;

	"Liters to U.K. Gallons")
		output_conversion=$(echo "scale=3; $VALUE/$gallonUK_liter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Liters to U.K. Gallons: $VALUE lt = $output_conversion U.K. Gallons." --title "Result Of The Conversion"); fi  ;;

	"U.S. Gallons (Liquid) to Liters")
		output_conversion=$(echo "scale=3; $VALUE*$gallonUSliquid_liter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Gallons (Liquid) to Liters: $VALUE U.S. Gallons (Liquid) = $output_conversion lt." --title "Result Of The Conversion"); fi  ;;

	"Liters to U.S. Gallons (Liquid)")
		output_conversion=$(echo "scale=3; $VALUE/$gallonUSliquid_liter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Liters to U.S. Gallons (Liquid): $VALUE lt = $output_conversion U.S. Gallons (Liquid)." --title "Result Of The Conversion"); fi  ;;

	"U.S. Gallons (Dry) to Liters")
		output_conversion=$(echo "scale=3; $VALUE*$gallonUSdry_liter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from U.S. Gallons (Dry) to Liters: $VALUE U.S. Gallons (Dry) = $output_conversion lt." --title "Result Of The Conversion"); fi  ;;

	"Liters to U.S. Gallons (Dry)")
		output_conversion=$(echo "scale=3; $VALUE/$gallonUSdry_liter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Liters to U.S. Gallons (Dry): $VALUE lt = $output_conversion U.S. Gallons (Dry)." --title "Result Of The Conversion"); fi  ;;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   AREA   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"Acres to Sq Meters") 
		output_conversion=$(echo "scale=3; $VALUE*$acre_sqmeter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Acres to Square Meters: $VALUE Acres = $output_conversion Sq mt." --title "Result Of The Conversion"); fi  ;;

	"Sq Meters to Acres") 
		output_conversion=$(echo "scale=3; $VALUE/$acre_sqmeter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Square Meters  to Acres: $VALUE Sq mt. = $output_conversion Acres " --title "Result Of The Conversion"); fi  ;;

	"Sq Feet to Sq Meters") 
		output_conversion=$(echo "scale=3; $VALUE*$sqfoot_sqmeter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Square Feet to Square Meters: $VALUE Sq Feet = $output_conversion Sq mt." --title "Result Of The Conversion"); fi  ;;

	"Sq Meters to Sq Feet") 
		output_conversion=$(echo "scale=3; $VALUE/$sqfoot_sqmeter" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Square Meters to Square Feet: $VALUE Sq mt = $output_conversion Sq Feet." --title "Result Of The Conversion"); fi  ;;


# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   VELOCITY   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"Km/hr to Miles/hr") 
		output_conversion=$(echo "scale=3; $VALUE*$Kmph_mph" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Km/hr to Miles/hr: $VALUE Km/hr = $output_conversion Miles/hr." --title "Result Of The Conversion"); fi  ;;

	"Miles/hr to Km/hr") 
		output_conversion=$(echo "scale=3; $VALUE/$Kmph_mph" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else(kdialog --msgbox "Conversion from Miles/hr to Km/hr: $VALUE Miles/hr = $output_conversion Km/hr." --title "Result Of The Conversion"); fi  ;;

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~   DEGREES   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"Degrees to Radians") 
		PI=3.141592653589793116
		VALUE_within_360=$(echo "$VALUE%360" | bc)
		output_conversion=$(echo "$VALUE_within_360*$degree_radian" | bc)
		coefficient_PI==$(echo "scale=3; $output_conversion/$PI" | bc)
		if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
		else( 
			if [ $VALUE_within_360 != $VALUE ]; then kdialog --msgbox "Conversion from Degrees to Radians: $VALUE deg (which for conversion purposes is equivalent to $VALUE_within_360 deg) = $output_conversion rad (that is $coefficient_PI * PI rad) ." --title "Result Of The Conversion"
			else kdialog --msgbox "Conversion from Degrees to Radians: $VALUE deg = $output_conversion rad, that is $coefficient_PI * PI rad." --title "Result Of The Conversion"; fi  ); fi  ;;

	"Radians to Degrees")
		invalid_radiant_value=0 
		invalid_radiant_value=$(echo "$VALUE>6.283185" | bc)
		if [ $invalid_radiant_value -ne 0 ]; then  (kdialog --error "Invalid value. Radian is defined as equal to the angle at the center of a circle subtended by an arc equal in length to the radius. Thus its legal values span from 0 to 2*PI, that is approximatively 6.283185." --title "Invalid Value for Radian" ; exit)
		else 
			output_conversion=$(echo "scale=3; $VALUE/$degree_radian" | bc)
			if [ -z "$output_conversion" ]; then (kdialog --error "Invalid value. Make sure your input contains only numbers." --title "Invalid Value"; exit)
			else(kdialog --msgbox "Conversion from Radians to Degrees: $VALUE rad = $output_conversion deg." --title "Result Of The Conversion"); fi  
		 fi ;; 
		     

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	"~~~~~~~~~~~~~~~~")
		kdialog --error "Invalid selection. Symbols '~~~~~~~~' are just separators, you must select a valid entry." --title "Invalid Selection" ;;


	*) kdialog --error "An unexpected error occurred";;
esac
